SystemOrganization addCategory: #'Compiler-Shout'!

Object subclass: #CodeStyler
	instanceVariableNames: 'methodStyler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compiler-Shout'!

!CodeStyler methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/29/2011 23:15'!
methodStyler
	^methodStyler ifNil: [methodStyler := MethodCodeStyler new].
! !

Object subclass: #MethodCodeStyler
	instanceVariableNames: 'styleTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compiler-Shout'!

!MethodCodeStyler methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/29/2011 22:44'!
rangeSyntaxAttributesFor: aString in: aClassOrMetaclass workspace: workspace env: env
	^(0 to: 0)! !

!MethodCodeStyler methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/29/2011 17:55'!
styleArray
	^SHTextStylerST80 defaultStyleTable.! !

!MethodCodeStyler methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/29/2011 17:55'!
styleTable
	^styleTable ifNil: [styleTable := StyleTable for: self].! !

Object subclass: #StyleTable
	instanceVariableNames: 'refToStyleArray textAttributesByPixelHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compiler-Shout'!

!StyleTable class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/29/2011 16:47'!
for: anObject
	^self new refToStyleArray: anObject; yourself.! !

!StyleTable methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/29/2011 16:04'!
attributeArrayForColor: aColorOrNil emphasis: anEmphasisSymbolOrArrayorNil font: aTextStyleOrFontOrNil 
	| emphArray answer |
	answer := Array new.
	aColorOrNil
		ifNotNil: [answer := answer , {TextColor color: aColorOrNil}].
	anEmphasisSymbolOrArrayorNil
		ifNotNil: [emphArray := anEmphasisSymbolOrArrayorNil isSymbol
						ifTrue: [{anEmphasisSymbolOrArrayorNil}]
						ifFalse: [anEmphasisSymbolOrArrayorNil].
			emphArray
				do: [:each | each ~= #normal
						ifTrue: [answer := answer , {TextEmphasis perform: each}]]].
	aTextStyleOrFontOrNil
		ifNotNil: [answer := answer , {TextFontReference toFont: aTextStyleOrFontOrNil}].
	^ answer! !

!StyleTable methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/29/2011 15:59'!
attributesFor: aSymbol pixelHeight: aNumber 
	^ (self textAttributesByPixelHeight
		at: aNumber
		ifAbsentPut: [self initialTextAttributesForPixelHeight: aNumber])
		at: aSymbol
		ifAbsent: []! !

!StyleTable methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/29/2011 16:04'!
initialTextAttributesForPixelHeight: aNumber 
	| d |
	d := IdentityDictionary new.
	self styleTable
		do: [:each | 
			| textStyle element emphasis font pixelHeight attrArray color textStyleName |
			element := each first.
			color := each
						at: 2
						ifAbsent: [].
			color := color
						ifNotNil: [Color colorFrom: color].
			emphasis := each
						at: 3
						ifAbsent: [].
			textStyleName := each
						at: 4
						ifAbsent: [].
			pixelHeight := each
						at: 5
						ifAbsent: [aNumber].
			textStyleName
				ifNil: [pixelHeight := nil].
			textStyle := TextStyle named: textStyleName.
			font := textStyle
						ifNotNil: [pixelHeight
								ifNotNil: [textStyle fontOfSize: pixelHeight]].
			attrArray := self
						attributeArrayForColor: color
						emphasis: emphasis
						font: font.
			attrArray notEmpty
				ifTrue: [d at: element put: attrArray]].
	^ d! !

!StyleTable methodsFor: 'accessing' stamp: 'EstebanAllende 11/29/2011 16:11'!
refToStyleArray

	^ refToStyleArray! !

!StyleTable methodsFor: 'accessing' stamp: 'EstebanAllende 11/29/2011 16:12'!
refToStyleArray: anObject

	refToStyleArray := anObject.
	textAttributesByPixelHeight := nil.! !

!StyleTable methodsFor: 'accessing' stamp: 'EstebanAllende 11/29/2011 16:12'!
styleTable

	^ refToStyleArray styleArray.! !

!StyleTable methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/29/2011 16:01'!
textAttributesByPixelHeight
	^ textAttributesByPixelHeight
		ifNil: [textAttributesByPixelHeight := Dictionary new]! !

!StyleTable methodsFor: 'accessing' stamp: 'EstebanAllende 11/29/2011 16:06'!
textAttributesByPixelHeight: anObject

	textAttributesByPixelHeight := anObject! !
